﻿@page "/competitionParents"
@using Models.CompetitionData
@using Business.Repository.IRepository
@inject ICompetitionParentRepository CompetitionParentRepository
@inject IJSRuntime JsRuntime
@inject Blazored.LocalStorage.ILocalStorageService localStorage
@inject NavigationManager NavigationManager

<div class="row mt-4">
    <div class="col-8">
        <h4 class="card-title text-info">Leagues</h4>
    </div>
    <div class="col-3 offset-1">
        <NavLink href="competitionParents/create" class="btn btn-primary form-control">Add new league</NavLink>
    </div>
</div>
<div class="row mt-4">
    <div class="col-12">
        <table class="table table-bordered table-hover">
            <thead>
                <tr>
                    <th width="5%" class="text-center">#</th>
                    <th width="50%" class="text-center">League Name</th>
                    <th width="20%">
                        Actions
                    </th>
                </tr>
            </thead>
            <tbody>
                @if (CompetitionParents.Any())
                {
                    int i = 1;
                    @foreach (var competitionParent in CompetitionParents)
                    {
                        <tr>
                            <td class="text-center">@i</td>
                            @{i++;}
                            <td class="text-center">@competitionParent.Name</td>
                            <td>
                                <NavLink href="@($"competitions/{competitionParent.Id}")" class="btn btn-primary">Competitions</NavLink>
                                <NavLink href="@($"competitionParents/edit/{competitionParent.Id}")" class="btn btn-primary">Edit</NavLink>
                                <button class="btn btn-danger" @onclick="() => HandleDelete(competitionParent.Id)">Delete</button>
                            </td>
                        </tr>
                    }
                }
                else
                {
                    <tr>
                        <td colspan="5">No records found</td>
                    </tr>
                }
            </tbody>
        </table>
    </div>
</div>

<DeleteConfirmation IsParentComponentProcessing="IsProcessing" ConfirmationChanged="ConfirmDelete_Click"></DeleteConfirmation>

@code {
    private IEnumerable<CompetitionParentDTO> CompetitionParents { get; set; } = new List<CompetitionParentDTO>();
    private int? DeleteCompetitionParentId { get; set; } = null;
    private bool IsProcessing { get; set; } = false;

    protected async override Task OnInitializedAsync()
    {
        CompetitionParents = await CompetitionParentRepository.GetAllFromSeason(await localStorage.GetItemAsync<int>("seasonId"));
    }

    private async Task HandleDelete(int competitionParentId)
    {
        DeleteCompetitionParentId = competitionParentId;
        await JsRuntime.InvokeVoidAsync("ShowDeleteConfirmationModal");
    }
    public async Task ConfirmDelete_Click(bool isConfirmed)
    {
        IsProcessing = true;
        if (isConfirmed && DeleteCompetitionParentId != null)
        {
            await CompetitionParentRepository.Delete(DeleteCompetitionParentId.Value);
            await JsRuntime.ToastrSuccess("CompetitionParent deleted successfully!");
            CompetitionParents = await CompetitionParentRepository.GetAllFromSeason(await localStorage.GetItemAsync<int>("seasonId"));
        }
        await JsRuntime.InvokeVoidAsync("HideDeleteConfirmationModal");
        IsProcessing = false;
    }
}
